module RspecDelivery
	class Message

		attr_accessor :rspec_data, :tracker_data

		def initialize(rspec_data)
			puts "\n\n"
			puts "duration: #{(rspec_data[:duration].to_f / 60).to_s[0..5]} mins.\n"
			puts "example_count: #{rspec_data[:example_count]}\n"
			puts "failure_count: #{rspec_data[:failure_count]}\n"
			puts "success_rate: #{((1 - (rspec_data[:failure_count].to_f/rspec_data[:example_count].to_f)) * 100).to_s[0..5]}% \n\n"
			@rspec_data = rspec_data
		end

		def send(endpoint)
			response = HTTParty.post(endpoint, 
										body: { 
											rspec_data: self.rspec_data,
											errors: self.tracker_data.errors,
											successes: self.tracker_data.successes,
											pending: self.tracker_data.pending
										}.to_json,
										headers: {
											'Content-Type' => 'application/json'
										}
									)

			puts "RSpec Delivery Response Status: #{response.code}"
			body = response.body
			if body.blank? || body == ''
				body = '<no server response body>'
			end
			puts "RSpec Delivery Response Body: #{body}"
		end

	end
end