module RspecDelivery
	class Tracker

		attr_accessor :errors, :successes, :pending

		def initialize
			@errors = []
			@successes = []
			@pending = []
		end

		def add(example)
			# TODO, add exception message (an RSPEC::Expectation::Message obj)
			status = example.execution_result[:status]

			message = {
				description: example.full_description,
				status: status,
				run_time: example.execution_result[:run_time],
				file_path: example.file_path,
				line_number: example.location.split('.rb:')[1]
			}

			if status == "failed"
				@errors << message
			elsif status == "passed"
				@successes << message
			elsif status == "pending"
				@pending << message
			end
			
		end

	end
end